VERSION 5.00
Begin VB.Form frmMain 
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   60
   ClientWidth     =   4680
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Visible         =   0   'False
   WindowState     =   2  'Maximized
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'--------------------------------------------------------------------------------
' Name: SnowMan
' Desc: DirectX 8 example of sprites, backbuffer surface, Primary surface
' Created By: KeithS
' Create Date: 1/10/2002
' Copyright 2002 Keith Sink
' Notes:
'--------------------------------------------------------------------------------
Option Explicit

Dim oDX As DirectX8               ' The core DirectX object
Dim oD3D As Direct3D8             ' The core Direct3D object
Dim oD3DDevice As Direct3DDevice8 ' This initializes the 3D video card.
Dim oD3DX As D3DX8                ' Additional Direct3D class libraries
Dim oD3DT As Direct3DTexture8     ' Background(snowman) texture
Dim oD3DT2 As Direct3DTexture8    ' Flake texture
Dim oDI As DirectInput8                  ' DirectInput object(for keyboard and mouse)
Dim oDIDevKeyboard As DirectInputDevice8 ' Keyboard Device
Dim oDIStateKeyboard As DIKEYBOARDSTATE  ' Keyboard State
Dim oDIDevMouse As DirectInputDevice8    ' Mouse Device
Dim oDIStateMouse As DIMOUSESTATE        ' Mouse State

Public bRunning As Boolean           ' Controls the execution loop
Public lNumberOfFlakes As Integer
Dim SnowPileX(640) As Integer ' For tracking snowpile
Public lLastMouseX As Long
Public lLastMouseY As Long
    
Private Type FlakeType
  PositionX As Single
  PositionY As Single
  SpeedX As Single
  SpeedY As Single
End Type

Private Flakes() As FlakeType

'This structure describes a custom vertex.
Private Type CUSTOMVERTEX
    X As Single
    Y As Single
    Z As Single
    rhw As Single
    color As Long
    specular As Long
    tu As Single
    tv As Single
End Type

'Creates our two objects: The snowflake and the background.
Dim TriStrip(0 To 3) As CUSTOMVERTEX    ' Background
Dim TriStrip2(0 To 3) As CUSTOMVERTEX   ' SnowFlake

'avoid seeing mouse cursor
'Private Declare Function ShowCursor Lib "user32" (ByVal bShow As Long) As Long

Private Sub Form_Load()
    
    Dim oldTime As Long
    
    lNumberOfFlakes = GetSetting(App.EXEName, "Settings", "Number of Snowflakes", 100)
    
    ReDim Flakes(lNumberOfFlakes)
    
    ResetSnowPile
       
    Me.Show
    
    bRunning = InitializeEnvironment()
        
    'Check the mouse buffer
    oDIDevMouse.GetDeviceStateMouse oDIStateMouse
        
    'Set the initial mouse X value
    lLastMouseX = oDIStateMouse.lX
    
    'Set the initial mouse Y value
    lLastMouseY = oDIStateMouse.lY
        
    ' Main execution loop
    Do While bRunning
        
        Animate ' Draw the screen animation
                         
        CheckKeyboard ' Check the keyboard buffer
        CheckMouse ' Check the mouse buffer
        
        DoEvents ' This is required by DirectX.
                 ' Failure to use this may cause problems.
                 
    Loop
    
    On Error Resume Next ' Keep going if the objects were never created.
    
    CleanUp
    Unload Me
   
End Sub
'--------------------------------------------------------------------------------
' Name: CheckKeyboard
' Desc: This routine checks the keyboard buffer for a change.
'
' Created By: KeithS
' Create Date: 1/11/2002
' Input: None
' Output: None
' Notes:
'--------------------------------------------------------------------------------
Sub CheckKeyboard()
    Dim iKeyCounter As Integer
    
    'Check the keyboard buffer
    oDIDevKeyboard.GetDeviceStateKeyboard oDIStateKeyboard

    For iKeyCounter = 0 To 255
        If oDIStateKeyboard.Key(iKeyCounter) <> 0 Then
            bRunning = False
        End If
    Next
End Sub

'--------------------------------------------------------------------------------
' Name: CheckMouse
' Desc: This routine checks the mouse buffer for a change in position.
'
' Created By: KeithS
' Create Date: 1/11/2002
' Input: None
' Output: None
' Notes:
'--------------------------------------------------------------------------------
Sub CheckMouse()
    
    'Check the mouse buffer
    oDIDevMouse.GetDeviceStateMouse oDIStateMouse
    
    'Has the mouse moved left or right?
    If oDIStateMouse.lX <> lLastMouseX Then bRunning = False
    
    'How about up and down?
    If oDIStateMouse.lY <> lLastMouseY Then bRunning = False
    
End Sub
'--------------------------------------------------------------------------------
' Name: Validate_Position
' Desc: This routine adjusts the flakes X, Y and speed if necessary.
'
' Created By: KeithS
' Create Date: 6/16/2000
' Input: Flake - The id of the flake in the flake array.
' Output: None
' Notes:
'--------------------------------------------------------------------------------
Sub Validate_Position(Flake)

    Dim iCount As Integer
    Dim r As Integer
  
    ' Move our Flakes left and right
    r = Rnd(1)
    If r > 0 Then
        Flakes(Flake).SpeedX = -Flakes(Flake).SpeedX
    End If

    ' Check the X coordinate of the Flake
    If Flakes(Flake).PositionX < 5 Then
       Flakes(Flake).SpeedX = -Flakes(Flake).SpeedX
       Flakes(Flake).PositionX = 5
    ElseIf Flakes(Flake).PositionX > 630 Then
       Flakes(Flake).SpeedX = -Flakes(Flake).SpeedX
       Flakes(Flake).PositionX = 630
    End If
 
    'Restart the Flake at the top(Recycle)
    If Flakes(Flake).PositionY > 475 Then
       Flakes(Flake).PositionY = 5
       Flakes(Flake).PositionX = 1 + Int(630 * Rnd())
    End If
 
End Sub
'--------------------------------------------------------------------------------
' Name: DrawFlakes
' Desc: This subroutine handles the BltFast operations. First we blit the Snowman
'       surface to the backbuffer, then each of the Flakes. If we did this
'       in the opposite order, you would see the Flakes falling behind a
'       black backdrop behind the snowman.
'
' Created By: KeithS
' Create Date: 6/16/2000
' Input: None
' Output: None
' Notes:
'--------------------------------------------------------------------------------
Sub DrawFlakes()
  On Error GoTo Err_DrawFlakes
 
    Dim iCount As Integer
    
    'Draw Flakes
    For iCount = 1 To lNumberOfFlakes
    
        'Reposition the flake
        Move_Flake Flakes(iCount).PositionX, Flakes(iCount).PositionY
       
       ' Draw the flake
        oD3DDevice.SetTexture 0, oD3DT2 ' Use the flake texture
        oD3DDevice.DrawPrimitiveUP D3DPT_TRIANGLESTRIP, 2, TriStrip2(0), Len(TriStrip2(0))
         
    Next iCount

Exit Sub
Err_DrawFlakes:
If Err.Number = 9 Then ' This means the snow is up to the top of the screen,
                       ' so just reset everything.
    Err.Clear
    ResetSnowPile
Else
    MsgBox Err.Description & "in DrawFlakes"
End If
End Sub
'--------------------------------------------------------------------------------
' Name: ResetSnowPile
' Desc: Sets the snow line for the screen. You can adjust this so that the snow
'       won't fall below the snowman, but stack on top of him.
' Created By: KeithS
' Create Date: 6/16/2000
' Input: None
' Output: None
' Notes:
'--------------------------------------------------------------------------------
Sub ResetSnowPile()
   
    ' Assign the values for the snowman, so we don't drown him in snow.
    Dim iCount As Integer
    
    For iCount = 1 To 639
        SnowPileX(iCount) = 457 ' Don't let snow go below this point on the Y axis.
    Next iCount
    
End Sub

'--------------------------------------------------------------------------------
' Name: MoveFlake
' Desc: Moves our Flakes to their new X,Y positions at every timer count.
' Created By: KeithS
' Create Date: 6/16/2000
' Input: None
' Output: None
' Notes:
'--------------------------------------------------------------------------------
Sub MoveFlake()
On Error GoTo err_MoveFlake
    
    Dim iCount As Integer
      
    'Flakes stuff
    For iCount = 1 To lNumberOfFlakes
        With Flakes(iCount)
            .PositionX = .PositionX + .SpeedX
            .PositionY = .PositionY + .SpeedY
            
            Validate_Position iCount
        End With
    Next iCount
    Exit Sub

err_MoveFlake:
    MsgBox "Error in MoveFlake Module."
    Err.Clear
    Resume Next
End Sub

'--------------------------------------------------------------------------------
' Name: REC
' Desc: Creates a RECT object with the specified dimensions.
' Created By: KeithS
' Create Date: 6/16/2000
' Input: None
' Output: None
' Return: RECT object
' Notes:
'--------------------------------------------------------------------------------
Function REC(X, Y, x1, y1) As RECT
    With REC
        .Left = X
        .Right = x1
        .bottom = y1
        .Top = Y
    End With
End Function
'--------------------------------------------------------------------------------
' Name: CleanUp
' Desc: Cleans up the DirectX objects we've created. It's very important to do
'       this at the end of execution.
' Created By: KeithS
' Create Date: 6/16/2000
' Input: None
' Output: None
' Notes:
'--------------------------------------------------------------------------------
Sub CleanUp()
 
    ' Stop execution
    bRunning = False
    
    oDIDevKeyboard.Unacquire ' Release the keyboard lock you have.
    oDIDevMouse.Unacquire ' Release the mouse lock you have.
    
    'Release these objects
    Set oDI = Nothing
    Set oD3DT = Nothing
    Set oD3DX = Nothing
    Set oD3DDevice = Nothing
    Set oD3D = Nothing
    Set oDX = Nothing


    'ShowCursor 1 'Return the Mouse cursor to normal operation.
    End

End Sub

'*****************************************************************************
'** ObjectName:  InitializeEnvironment
'**
'** Description: This function does the following:
'**                 1. Initializes the DirectX, Direct3D, and D3DX8 objects.
'**                 2. Initializes and defines the transparency color.
'**                 3. Sets up a 640x480 24-bit display mode.
'**                 4. Sets up the Direct3D present parameters.
'**                 5. Creates and sets up a Direct3D device.
'**                 6. Sets up the renderstate and vertex shader of the device.
'**                 7. Creates the background and flake textures from files.
'**                 8. Calls the InitializeVertices function.
'**
'*****************************************************************************
Public Function InitializeEnvironment() As Boolean
    On Error GoTo Err_InitializeEnvironment

    Dim iCount As Long
    
    Dim DispMode As D3DDISPLAYMODE          ' Display mode descriptor
    Dim oD3DWindow As D3DPRESENT_PARAMETERS ' Window or viewport that will
                                            ' be used to display images.
    Dim lColorKeyVal As Long                ' Colorkey for transparency
    
    ' Setup your DirectX objects
    Set oDX = New DirectX8                  ' Create your DirectX object
    Set oD3D = oDX.Direct3DCreate()         ' Create your Direct3D object from the DX object.
    Set oD3DX = New D3DX8                   ' Additional Direct3D class libraries
    Set oDI = oDX.DirectInputCreate         ' Create your DirectInput object
    Set oDIDevKeyboard = oDI.CreateDevice("GUID_SysKeyboard") ' Create a DirectInput Keyboard Device
    Set oDIDevMouse = oDI.CreateDevice("GUID_SysMouse") ' Create a DirectInput Mouse Device
    
    ' Setup the Keyboard attributes
    oDIDevKeyboard.SetCommonDataFormat DIFORMAT_KEYBOARD
    oDIDevKeyboard.SetCooperativeLevel Me.hWnd, DISCL_BACKGROUND Or DISCL_NONEXCLUSIVE
    
    oDIDevKeyboard.Acquire ' Acquire the Keyboard device
    
    ' Setup the mouse attributes
    oDIDevMouse.SetCommonDataFormat DIFORMAT_MOUSE
    oDIDevMouse.SetCooperativeLevel Me.hWnd, DISCL_BACKGROUND Or DISCL_NONEXCLUSIVE
    
    oDIDevMouse.Acquire ' Acquire the Mouse device
    
    lColorKeyVal = &HFFFF0000               ' Red is the transparency color
   
    'hide the mouse cursor
    'ShowCursor 0
  
    With DispMode
        .Format = D3DFMT_R5G6B5             ' 24-bit RGB pixel format
        .Width = 640
        .Height = 480
    End With
    
    With oD3DWindow
        .SwapEffect = D3DSWAPEFFECT_FLIP    ' Type of flipping to use.
        .BackBufferCount = 1                ' 1 backbuffer
        .BackBufferFormat = DispMode.Format ' Display format
        .BackBufferHeight = 480
        .BackBufferWidth = 640
        .hDeviceWindow = frmMain.hWnd       ' Where to display the finished product.
    End With
    
    ' Creates the Direct3D hardware device
    Set oD3DDevice = oD3D.CreateDevice(D3DADAPTER_DEFAULT, _
                            D3DDEVTYPE_HAL, _
                            frmMain.hWnd, _
                            D3DCREATE_SOFTWARE_VERTEXPROCESSING, _
                            oD3DWindow)
    
    With oD3DDevice
    
        ' Setup the vertex shader
        .SetVertexShader D3DFVF_XYZRHW Or D3DFVF_TEX1 Or D3DFVF_DIFFUSE Or D3DFVF_SPECULAR
    
        ' Set render states for the device
        ' --------------------------------
        ' Source blend
        .SetRenderState D3DRS_SRCBLEND, D3DBLEND_SRCALPHA
        ' Destination blend
        .SetRenderState D3DRS_DESTBLEND, D3DBLEND_INVSRCALPHA
        ' Alpha blending
        .SetRenderState D3DRS_ALPHABLENDENABLE, True
    End With
    
    ' Load the snowman scene texture
    Set oD3DT = oD3DX.CreateTextureFromFile(oD3DDevice, _
            App.Path & "\snowman.bmp")
    
    ' Load the snowflake texture
    Set oD3DT2 = oD3DX.CreateTextureFromFileEx(oD3DDevice, _
            App.Path & "\flake.bmp", 2, 2, _
            D3DX_DEFAULT, 0, D3DFMT_UNKNOWN, _
            D3DPOOL_MANAGED, D3DX_FILTER_POINT, _
            D3DX_FILTER_POINT, lColorKeyVal, _
            ByVal 0, ByVal 0)
    
    ' Randomly choose the position of each flake on the screen.
    For iCount = 1 To lNumberOfFlakes
       With Flakes(iCount)
           .PositionX = 1 + Int(640 * Rnd()) '640 * Rnd
           .PositionY = 1 + Int(400 * Rnd()) '400 * Rnd
           
           'set and normalize Flake speed
           .SpeedX = 0.1
           .SpeedY = 0.3
       End With
    Next iCount
 
    ' Make sure the background vertices were created.
    If InitialiseVertices() = True Then
        InitializeEnvironment = True
        Exit Function
    End If
    
    Exit Function
    
Err_InitializeEnvironment:
    MsgBox "Error Number Returned: " & Err.Number & " Error Message: " & Err.Description
    InitializeEnvironment = False
End Function
'*****************************************************************************
'** ObjectName:  Animate
'**
'** Description: This subroutine does the following:
'**                 1. Clear the Direct3DDevice object.
'**                 2. Begin the render of the scene.
'**                 3. Assign a texture to the Direct3DDevice object(background).
'**                 4. Draw the trianglestrip for our background.
'**                 5. Assign a texture to the Direct3DDevice object(snowflake).
'**                 6. Draw the trianglestrip for our snowflake.
'**                 7. End the render of the scene.
'**                 8. Present this frame of animation to the screen.
'**
'*****************************************************************************
Public Sub Animate()
On Error GoTo err_Animate

    MoveFlake ' Move the snowflakes

    With oD3DDevice
        .Clear 0, ByVal 0, D3DCLEAR_TARGET, 0, 1#, 0 '//Clear the screen black
        
        .BeginScene ' Start drawing
        
            ' Draw background
            .SetTexture 0, oD3DT ' Use the background texture
            .DrawPrimitiveUP D3DPT_TRIANGLESTRIP, 2, TriStrip(0), Len(TriStrip(0))
        
            DrawFlakes
        
        .EndScene ' End drawing
        .ShowCursor 0
        .Present ByVal 0, ByVal 0, 0, ByVal 0
    End With

    Exit Sub
err_Animate:
    If Err.Number = -2005530520 Then ' This error occurs when stopping the snowman.
        Err.Clear
        Resume Next
    Else
        MsgBox Err.Number & Err.Description & " Error in Animate Module."
        Err.Clear
        Resume Next
    End If

End Sub
'*****************************************************************************
'** ObjectName:  InitialiseVertices
'**
'** Description: This function creates the vertices for the background.
'**
'*****************************************************************************
Private Function InitialiseVertices() As Boolean
    
    On Error GoTo Err_InitialiseVertices:
    
    ' The vertex is layed out to encompas the whole 640 x 480 screen
    ' (0)-------------(1)
    '                /
    '               /
    '              /
    '             /
    '            /
    '           /
    '          /
    '         /
    '        /
    '       /
    '      /
    '     /
    '    /
    ' (2)-------------(3)
    
        TriStrip(0) = CreateVertex(10, 10, 0, 1, RGB(255, 255, 255), 0, 0, 0)
        TriStrip(1) = CreateVertex(640, 10, 0, 1, RGB(255, 255, 255), 0, 1, 0)
        TriStrip(2) = CreateVertex(10, 480, 0, 1, RGB(255, 255, 255), 0, 0, 1)
        TriStrip(3) = CreateVertex(640, 480, 0, 1, RGB(255, 255, 255), 0, 1, 1)
    
    InitialiseVertices = True
    Exit Function
    
Err_InitialiseVertices:
    InitialiseVertices = False
    
End Function

'*****************************************************************************
'** ObjectName:  CreateVertex
'**
'** Description: This function wraps the properties of the CUSTOMVERTEX object
'**              so that we can quickly populate it.
'**
'*****************************************************************************
Private Function CreateVertex(X As Single, Y As Single, Z As Single, rhw As Single, color As Long, specular As Long, tu As Single, tv As Single) As CUSTOMVERTEX
    
    With CreateVertex
        .X = X
        .Y = Y
        .Z = Z
        .rhw = rhw
        .color = color
        .specular = specular
        .tu = tu
        .tv = tv
    End With
    
End Function
'*****************************************************************************
'** ObjectName:  Move_Flake
'**
'** Description: Repositions the vertices of the flake to the new coordinates.
'*****************************************************************************
Private Sub Move_Flake(X As Single, Y As Single)
    ' Flake vertices
    TriStrip2(0) = CreateVertex(X - 2, Y - 2, 0, 1, RGB(255, 255, 255), 0, 0, 0)
    TriStrip2(1) = CreateVertex(X + 2, Y - 2, 0, 1, RGB(255, 255, 255), 0, 1, 0)
    TriStrip2(2) = CreateVertex(X - 2, Y + 2, 0, 1, RGB(255, 255, 255), 0, 0, 1)
    TriStrip2(3) = CreateVertex(X + 2, Y + 2, 0, 1, RGB(255, 255, 255), 0, 1, 1)
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
  CleanUp ' Call the cleanup routine.
End Sub
